package com.unis.common.utils;

import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class OrgUtil {

    /**
     * 获取父组织code,无则为空
     * @param code
     * @return
     */
    public static String getParentOrg(String code){
        if(StringUtils.isNotEmpty(code)){
            code=code.trim();
            int len=code.length();
            if(len>5){
                return  code.substring(0,len-3);
            }
            return null;
        }
        return null;
    }

    /**
     * 获取组织级别.省0   市1  县2  企业3
     * @param code
     * @return
     */
    public static int getOrgLevel(String code){
        if(StringUtils.isNotEmpty(code)){
            code=code.trim();
            int len=code.length();
            return Math.min((len-5)/3,3);
        }
        throw new IllegalArgumentException("组织机构编码不能为空");
    }

    public static void main(String[] args) {

    }
}
