package com.unis.common.utils;

import java.util.UUID;
/**
 * uuid操作工具类：生成19位UUID，最短的UUID
 * @Author tiechanglong
 * @Date 2019/8/10 15:46
 * @Version 0.0.4
 **/
public class UUIDUtils {
	private static String digits(long val, int digits) {  
	    long hi = 1L << (digits * 4);  
	    return Numbers.toString(hi | (val & (hi - 1)), Numbers.MAX_RADIX)  
	            .substring(1);  
	}  
	  
	/** 
	 * 以62进制（字母加数字）生成19位UUID，最短的UUID 
	 *  
	 * @return 
	 */  
	public static String uuid() {  
	    UUID uuid = UUID.randomUUID();  
	    StringBuilder sb = new StringBuilder();  
	    sb.append(digits(uuid.getMostSignificantBits() >> 32, 8));  
	    sb.append(digits(uuid.getMostSignificantBits() >> 16, 4));  
	    sb.append(digits(uuid.getMostSignificantBits(), 4));  
	    sb.append(digits(uuid.getLeastSignificantBits() >> 48, 4));  
	    sb.append(digits(uuid.getLeastSignificantBits(), 12));  
	    return sb.toString();  
	}

	public static void main(String[] args) {
		String uuid = uuid();
		System.out.println(uuid);
	}
}
